(defun draw_pt (pt col / rap)
  (setq rap (/ (getvar "viewsize") 50))
  (foreach n
	     (mapcar '(lambda (x)
			(list ((eval (car x)) (car pt) rap)
			      ((eval (cadr x)) (cadr pt) rap)
			)
		      )
		     '((+ +) (+ -) (- +) (- -))
	     )
    (grdraw (trans pt 0 1) (trans n 0 1) col)
  )
)
(defun c:CABLAGE ( / js dxf_ent lay_name typ_cab obj_vlax e_length pt_start pt_end minpt maxpt key_cab key_usr lg_ext AcDoc Space pt deric rtx htx nw_obj)
	(princ "\nSlectionnez une polyligne ou entre pour en crer une.")
	(setq js
		(ssget "_+.:E:S"
			(list
				'(0 . "LWPOLYLINE")
				(cons 67 (if (eq (getvar "CVPORT") 1) 1 0))
				(cons 410 (getvar "CTAB"))
			)
		)
	)
  (if (null js)
    (progn
      (setvar "CMDECHO" 1)
      (command "_.pline"
        (while (not (zerop (getvar "cmdactive")))
          (command pause)
        )
      )
      (setq dxf_ent (entget (entlast)))
    )
    (setq dxf_ent (entget (ssname js 0)))
  )
  (cond
    ((eq (cdr (assoc 0 dxf_ent)) "LWPOLYLINE")
			(vlax-ldata-put "cablage" "3" 11.0)
			(vlax-ldata-put "cablage" "4" 3.0)
			(vlax-ldata-put "cablage" "5" 5.0)
			(vlax-ldata-put "cablage" "6" 2.5)
			(vlax-ldata-put "cablage" "7" 1.0)
			(vlax-ldata-put "cablage" "8" 2.0)
			(vlax-ldata-put "cablage" "9" 2.0)
			(vlax-ldata-put "cablage" "G" 2.0)
      (setq lay_name (cdr (assoc 8 dxf_ent)) key_usr "")
      (cond
        ((eq lay_name "Reseau Distribution Electrique Eclairage") (setq typ_cab "DISTRIBUTION-PUBLIC"))
        ((eq lay_name "Reseau Distribution Electrique Abonne") (setq typ_cab "DISTRIBUTION-PRIVE"))
        (T (setq typ_cab "DISTRIBUTION-Inconnue"))
      )
      (vl-load-com)
      (setq
        obj_vlax (vlax-ename->vla-object (cdar dxf_ent))
        e_length	(vlax-curve-getDistAtParam obj_vlax (vlax-curve-getEndParam obj_vlax))
        pt_start	(vlax-curve-getStartPoint obj_vlax)
        pt_end	(vlax-curve-getEndPoint obj_vlax)
      )
      (vla-GetBoundingBox obj_vlax 'mnpt 'mxpt)
      (setq
        minpt (trans (safearray-value mnpt) 0 1)
        maxpt (trans (safearray-value mxpt) 0 1)
      )
      (command "_.zoom" "_window" "_none" minpt "_none" maxpt "_.zoom" "0.75x")
      (redraw (cdar dxf_ent) 3)
      (draw_pt pt_start 7)
      (repeat 2
        (initget "poteauEP poteauBT Poste CAndelabre BOIte BORne COffret Armoire")
        (setq key_cab (getkword "\nBranchement pour cette extrmit sur [poteauEP/poteauBT/Poste/CAndelabre/BOIte/BORne/COffret/Armoire]? <Armoire>: "))
        (cond
          ((eq key_cab "poteauEP") (setq lg_ext (cons (cons 11 key_cab) lg_ext) key_usr (strcat "3" key_usr)))
          ((eq key_cab "poteauBT") (setq lg_ext (cons (cons 3 key_cab) lg_ext) key_usr (strcat "4" key_usr)))
          ((eq key_cab "Poste") (setq lg_ext (cons (cons 5 key_cab) lg_ext) key_usr (strcat "5" key_usr)))
          ((eq key_cab "CAndelabre") (setq lg_ext (cons (cons 2.5 key_cab) lg_ext) key_usr (strcat "6" key_usr)))
          ((eq key_cab "BOIte") (setq lg_ext (cons (cons 1 key_cab) lg_ext) key_usr (strcat "7" key_usr)))
          ((eq key_cab "BORne") (setq lg_ext (cons (cons 2 key_cab) lg_ext) key_usr (strcat "8" key_usr)))
          ((eq key_cab "COffret") (setq lg_ext (cons (cons 2 key_cab) lg_ext) key_usr (strcat "9" key_usr)))
          (T (setq key_cab "Armoire") (setq lg_ext (cons (cons 2 key_cab) lg_ext) key_usr (strcat "G" key_usr)))
        )
        (draw_pt pt_start -7)
        (draw_pt pt_end 7)
      )
      (draw_pt pt_end -7)
      (if (null (tblsearch "appid" "RESEAU_CABLAGE"))
        (regapp "RESEAU_CABLAGE")
      )
      (alert
        (strcat
          "Information attach  la polyligne mesurant : "
          (rtos e_length 2 2)
          "\net sur le calque : "
          lay_name
          "\n"
          "\nLongueur de cable attach : "
          (rtos (* 1.04 (+ e_length (caadr lg_ext) (caar lg_ext))) 2 2)
          "\nPour un(e) : " (strcase (cdadr lg_ext)) "  la 1ere extrmit."
          "\nEt pour un(e) : " (strcase (cdar lg_ext)) "  la 2me extrmit."
          "\nCeci pour une " typ_cab
        )
      )
      (redraw (cdar dxf_ent) 4)
      (setq
        AcDoc (vla-get-ActiveDocument (vlax-get-acad-object))
        Space
        (if (= 1 (getvar "CVPORT"))
          (vla-get-PaperSpace AcDoc)
          (vla-get-ModelSpace AcDoc)
        )
      )
      (cond
        ((null (tblsearch "LAYER" (strcat lay_name "-TXT")))
          (vla-add (vla-get-layers AcDoc) (strcat lay_name "-TXT"))
        )
      )
      (setq
        pt (vlax-curve-getPointAtDist obj_vlax (* 0.5 e_length))
        deriv (vlax-curve-getFirstDeriv obj_vlax (vlax-curve-getParamAtPoint obj_vlax pt))
        rtx (- (atan (cadr deriv) (car deriv)) (angle '(0 0 0) (getvar "UCSXDIR")))
      )
      (initget 6)
      (setq htx (getdist (trans pt 0 1) (strcat "\nSpcifiez la hauteur texte <" (rtos (getvar "TEXTSIZE")) ">: ")))
      (if htx (setvar "TEXTSIZE" htx))
      (if (or (> rtx (* pi 0.5)) (< rtx (- (* pi 0.5)))) (setq rtx (+ rtx pi)))
      (setq nw_obj
        (vla-addMtext Space
          (vlax-3d-point (setq pt (polar pt (+ rtx (* pi 0.5)) (getvar "TEXTSIZE"))))
          0.0
          (strcat
            "%<\\AcExpr ("
            "%<\\AcExpr ("
            (rtos (vlax-ldata-get "cablage" (substr key_usr 1 1)) 2 (getvar "LUPREC"))
            " + "
            (rtos (vlax-ldata-get "cablage" (substr key_usr 2 1)) 2 (getvar "LUPREC"))
            " + "
            "%<\\AcObjProp Object(%<\\_ObjId "
            (itoa (vla-get-ObjectID obj_vlax))
            ">%).Length>%)>% * 1.04) \\f \"%lu6\">%"
          )
        )
      )
      (mapcar
        '(lambda (pr val)
          (vlax-put nw_obj pr val)
        )
        (list 'AttachmentPoint 'Height 'DrawingDirection 'InsertionPoint 'StyleName 'Layer 'Rotation)
        (list 5 (getvar "TEXTSIZE") 5 pt (getvar "TEXTSTYLE") (strcat lay_name "-TXT") rtx)
      )
			(entmod
        (append
          dxf_ent
          (list
            (list -3
              (list
                "RESEAU_CABLAGE"
                (cons 1002 "{")
                (cons 1000 typ_cab)
                (cons 1000 (cdadr lg_ext))
                (cons 1040 (caadr lg_ext))
                (cons 1000 (cdar lg_ext))
                (cons 1040 (caar lg_ext))
                (cons 1000 "Longueur totale de cable")
                (cons 1040 (* 1.04 (+ e_length (caadr lg_ext) (caar lg_ext))))
                (cons 1002 "}")
              )
            )
          )
        )
      )
      (redraw)
    )
    (T (princ "\nN'est pas une polyligne!"))
  )
  (prin1)
)